; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"

            This test piece is designed to test redirection
                     on the windows.inc include file
        ----------------------------------------------------- *

    megabyte equ <1024*1024>

    .code

start:
   
; 

    call main

    exit

; 

main proc

    LOCAL pbuf  :DWORD
    LOCAL phex  :DWORD
    LOCAL blen  :DWORD

    mov pbuf, alloc(megabyte*2)     ; allocate a 2 meg buffer
    mov phex, alloc(megabyte*8)     ; 4 times larger for hex buffer

    invoke StdIn,pbuf,megabyte*2    ; get standard input
    mov blen, eax                   ; store the written length

    mov ecx, pbuf
    mov BYTE PTR [ecx+eax], 0       ; truncate output to written length
    add blen, 1                     ; display the terminator as well

    print "Input length of redirected file = "
    print str$(blen),13,10

    invoke bin2hex,pbuf,blen,phex   ; convert the file to hex notation

    print "Output length of written file = "
    print str$(len(phex)),13,10

    test OutputFile("yourfile.txt",phex,len(phex)), eax

    free phex
    free pbuf

    ret

main endp

; 

end start





